*  Glosprint Program
*  Code Size 2468 Bytes
*
         SIZE     200                        ; 200 Bytes data space
         GET      'RAM1_HEADER_ASM'          ; Get standard equates
*
OVER     MACRO
         MOVEQ    #SD.SETMD,D0               ; Set mode
         MOVEQ    #\1,D1                     ; Parameter
         TRAP     #3
         ENDM
*
WRITE    MACRO
         MOVE.W   UT.MTEXT,A2
         JSR      (A2)
         ENDM
*
CURSOFF  MACRO
         MOVEQ    #SD.CURS,D0                ; Supress cursor.
         TRAP     #3
         ENDM
*
CURSON   MACRO
         MOVEQ    #SD.CURE,D0                ; Enable cursor.
         TRAP     #3
         ENDM
*
*
* OFFSETS FROM VARIABLES ( used by main program )
CON      EQU      0
LOGO     EQU      4
SOURCE   EQU      8
DEST     EQU      12
MEM      EQU      16
JOB_ID   EQU      20
SV_BASE  EQU      24
*  OFFSETS FROM PARAMS ( Used by EDLINE subroutine only )
POSX     EQU      0
POSY     EQU      2
SEE_FLAG EQU      4
MAXLEN   EQU      6
EDIT     EQU      10
PROMPT   EQU      14

*
         GET      'ram2_PRINTJOB_KEYS'
*
ENTRY    BRA.S    START_P
         DS.B     4                          ; Skip 4 bytes
         DC.W     $4AFB                      ; Standard job format
         DC.W     9                          ; Name length
         DC.B     'GLOSPRINT',0              ; Program Name
*
START_P  LEA.L    0(A6,A5.L),A7              ; Set stackpointer
         MOVEQ    #MT.PRIOR,D0               ; Set Priority
         MOVEQ    #ME,D1                     ; Of this job
         MOVEQ    #1,D2                      ; To 1
         TRAP     #1
*
         LEA.L    VARIABLES,A6
         MOVEQ    #MT.INF,D0                 ; Get job_id
         TRAP     #1
         MOVE.L   D1,JOB_ID(A6)              ; Save job_id
         MOVE.L   A0,SV_BASE(A6)             ; Save sv_base
         MOVEQ    #MT.ALCHP,D0               ; Allocate memory
         MOVE.L   #128*42,D1                 ; No of bytes.
         MOVE.L   JOB_ID(A6),D2              ; Owned by me.
         TRAP     #1
         TST.L    D0
         BNE      END_JOB                    ; Not enough memory
         MOVE.L   A0,MEM(A6)                 ; Save ptr to mem.
         MOVE.L   #$20000+128*80,A1          ; Window pos no scr.
         MOVE.L   #42*32,D1                  ; No of bytes required.
SAVE_BK  MOVE.L   (A1)+,(A0)+                ; Save background.
         SUBQ.W   #1,D1
         BGT.S    SAVE_BK
         LEA.L    PBLOCK,A1                  ; Open console Window
         MOVE.W   UT.CON,A2
         JSR      (A2)
         TST.L    D0                         ; Error?
         BNE      END_JOB                    ; Yes, so leave
         MOVE.L   A0,CON(A6)                 ; Save console ID
         LEA.L    SBLOCK,A1                  ; Open Logo chan
         MOVE.W   UT.CON,A2
         JSR      (A2)
         TST.L    D0                         ; Error?
         BNE      END_JOB                    ; Yes, so leave
         MOVE.L   A0,LOGO(A6)                ; Save logo ID
         BSR      UPDATE                     ; Rewrite windows
         LEA.L    PARAMS,A5
         MOVE.W   #1,SEE_FLAG(A5)            ; Window is now visible.
*
*  Fetch filename from console
*
GET_FILE LEA.L    DEF1,A2                    ; A2 Ptr to line to edit
         LEA.L    MESSAGE1,A3                ; A3 Ptr to prompt
         BSR      BUFFER_SIZE                ; Get buffer size
         BSR      EDLINE
*
         LEA.L    DEF1,A0                    ; Fetched filename
         TST.W    (A0)                       ; No name at all ?
         BNE.S    S_EX
         LEA.L    RES1,A1                    ; Restore default.
         MOVE.W   (A1),D0
         MOVE.W   (A1)+,(A0)+
SDEF1    MOVE.B   (A1)+,(A0)+
         SUBQ.W   #1,D0
         BPL.S    SDEF1
         BRA      EXIT_QUE                   ; If so, end program
*
S_EX     MOVEQ    #OPEN_IN,D3                ; Open this file for input
         MOVEQ    #ME,D1                     ; File owned by me
         MOVEQ    #IO.OPEN,D0
         TRAP     #2
         TST.L    D0                         ; Error?
         BEQ.S    GOT_FILE                   ; No - so continue
*
         MOVEA.L  CON(A6),A0                 ; Else retrieve console channel ID,
         BSR      WRITE_ERR                  ; write error message,
         BRA.S    GET_FILE                   ; And try again.
*
GOT_FILE MOVE.L   A0,SOURCE(A6)              ; Save file channel ID.
         MOVEA.L  CON(A6),A0                 ; Make console current channel.
* Now get destination device specification from console.
GET_OUTP LEA.L    MESSAGE2,A3                ; A3 Ptr to prompt
         LEA.L    DEF2,A2                    ; A2 Ptr to line to edit
         BSR      BUFFER_SIZE                ; Get size of buffer
         BSR      EDLINE
*
         LEA.L    DEF2,A0                    ; Fetched name
         TST.W    (A0)                       ; No name at all ?
         BNE.S    D_EX
         LEA.L    RES2,A1                    ; Restore default.
         MOVE.W   (A1),D0
         MOVE.W   (A1)+,(A0)+
SDEF2    MOVE.B   (A1)+,(A0)+
         SUBQ.W   #1,D0
         BPL.S    SDEF2
         MOVE.L   SOURCE(A6),A0              ; Close source file
         MOVEQ    #IO.CLOSE,D0
         TRAP     #2
         BRA      GET_FILE                   ; and restart.
*
D_EX     MOVEQ    #OPEN_NEW,D3               ; Open file
         MOVEQ    #ME,D1                     ; owned by me
         MOVEQ    #IO.OPEN,D0
         TRAP     #2
         TST.L    D0                         ; Error?
         BEQ.S    GOT_OUTP                   ; No - so continue
*
         CMPI.L   #ERR.EX,D0                 ; Already exists ?
         BEQ.S    DEL_QUE
         MOVEA.L  CON(A6),A0                 ; Retrieve console channel ID
         BSR      WRITE_ERR                  ; Write error message,
         BRA.S    GET_OUTP                   ; And try again
*
DEL_QUE  MOVE.L   CON(A6),A0                 ; Use console.
         LEA.L    MESSAGE7,A3                ; A3 Ptr to prompt
         LEA.L    YN_ANS,A2                  ; A2 Ptr to line to edit
         MOVEQ    #1,D7                      ; Buffer size
         BSR      EDLINE
         LEA.L    YN_ANS,A2
         CMPI.B   #'Y',2(A2)
         BEQ.S    OVERWRITE
         CMPI.B   #'y',2(A2)
         BNE.S    GET_OUTP                   ; No overwriting.
OVERWRITE
         MOVEQ    #IO.DELET,D0               ; Delete file.
         MOVE.L   JOB_ID(A6),D1              ; I'm doing it!
         LEA.L    DEF2,A0                    ; File name.
         TRAP     #2
         LEA.L    DEF2,A0                    ; File name.
         BRA.S    D_EX                       ; Overwrite file.
*
GOT_OUTP MOVE.L   A0,DEST(A6)                ; Save printer channel ID.
         MOVEA.L  CON(A6),A0                 ; Make console current channel.
         LEA.L    HEAD_REQ,A3                ; Prompt
         LEA.L    HEADLINE,A2                ; Default reply
         BSR      BUFFER_SIZE                ; Get line length.
         BSR      EDLINE
*
         LEA.L    HEADLINE,A2
         TST.W    (A2)                       ; Esc pressed ?
         BNE.S    NO_CAN
         MOVEQ    #IO.CLOSE,D0               ; Close ...
         MOVE.L   DEST(A6),A0                ; Destination.
         TRAP     #2
         BRA      GET_OUTP                   ; Try to get it again.
*
NO_CAN   MOVEQ    #GREEN,D1
         BSR      SET_INK
         LEA.L    MESSAGE3,A1                ; Write:'Skapar...'
         MOVE.W   UT.MTEXT,A4
         JSR      (A4)
         LEA.L    LOG2_MES,A2
         BSR      WRITE_LOGO                 ; Rewrite status line
         MOVE.L   DEST(A6),A0                ; Write to destination.
         LEA.L    STRG1,A1                   ; Set Headline size.
         JSR      (A4)
         LEA.L    HEADLINE,A1                ; Write Headline.
         JSR      (A4)
         LEA.L    STRG2,A1                   ; Set normal char-size.
         JSR      (A4)
         LEA.L    STRG3,A1                   ; Write 'number of ...'
         JSR      (A4)
         MOVE.L   SOURCE(A6),A0              ; Use source channel.
         MOVEQ    #IO.FLINE,D0
         LEA.L    HOME_ST+2,A1               ; Position of buffer
         MOVEQ    #60,D2                     ; Buffer size.
         MOVEQ    #-1,D3                     ; Infinite timeout.
         TRAP     #3
         MOVE.L   DEST(A6),A0                ; Use destination channel.
         LEA.L    HOME_ST,A1                 ; Write number.
         MOVE.W   D1,(A1)                    ; Set linelength.
         JSR      (A4)
* Now convert it to integer format.
         LEA.L    HOME_ST,A2
         SUBI.W   #1,(A2)                    ; Convert the line into a string.
         MOVEQ    #0,D7                      ; Clear retval.
         MOVEQ    #0,D2                      ; Strpos.
         MOVEQ    #0,D3                      ; Sign.
         CMPI.B   #'-',2(A2)                 ; Negative ?
         BEQ.S    NEGATIVE
         CMPI.B   #'+',2(A2)                 ; Plus sign ?
         BNE.S    CALC                       ; No, start conversion.
         BRA.S    NEX_S
NEGATIVE MOVEQ    #1,D3                      ; Set sign.
NEX_S    ADDQ.W   #1,D2                      ; Inc Strpos.
CALC     CMP.W    (A2),D2                    ; Last digit converted ?
         BEQ.S    DONE
         MOVEQ    #0,D1
         MOVE.B   2(A2,D2.W),D1              ; Get new digit.
         SUBI.W   #'0',D1                    ; Make ASCII a number.
         MULU     #10,D7                     ; Make space for new digit.
         ADD.W    D1,D7
         ADDQ.W   #1,D2                      ; Inc Strpos.
         BRA.S    CALC
DONE     TST.W    D3                         ; Was it negative
         BEQ.S    CONVERTED
         NEG.W    D7                         ; If so set sign.
CONVERTED
         MOVEQ    #IO.SSTRG,D0               ; Send ...
         LEA.L    STRG2+10,A1
         MOVEQ    #3,D2                      ; Three linefeeds ...
         MOVEQ    #-1,D3                     ; Infinite timeout.
         TRAP     #3
CREATIVE_LOOP
         MOVE.L   SOURCE(A6),A0              ; Use source channel.
         MOVEQ    #IO.FLINE,D0
         LEA.L    HOME_ST+2,A1               ; Base of buffer
         MOVEQ    #60,D2                     ; Buffer size.
         MOVEQ    #-1,D3                     ; Infinite timeout.
         TRAP     #3
         LEA.L    HOME_ST,A1
         MOVE.W   D1,(A1)                    ; Set linelength
*
         MOVEQ    #IO.FLINE,D0
         LEA.L    FORE_ST+2,A1               ; Base of buffer
         TRAP     #3
         LEA.L    FORE_ST,A1
         MOVE.W   D1,(A1)                    ; Set linelength
*
         MOVE.L   DEST(A6),A0                ; Use destination channel.
         MOVEQ    #IO.SSTRG,D0
         LEA.L    STRG1+2,A1
         MOVEQ    #10,D2                     ; Send 10 spaces.
         MOVEQ    #-1,D3                     ; Infinite timeout.
         TRAP     #3
*
         LEA.L    FORE_ST,A1
         SUBI.W   #1,(A1)                    ; Convert line into a string.
         JSR      (A4)                       ; Send string.
*
         LEA.L    FORE_ST,A1
         MOVEQ    #30,D5
         SUB.W    (A1),D5                    ; No of spaces to fill in.
         BGT.S    COLUMN_OK
         MOVEQ    #1,D5
COLUMN_OK
         MOVEQ    #IO.SBYTE,D0
         MOVEQ    #' ',D1
         MOVEQ    #-1,D3                     ; Infinite timeout.
         TRAP     #3
         SUBQ.W   #1,D5
         BGT.S    COLUMN_OK
*
         LEA.L    HOME_ST,A1
         JSR      (A4)                       ; Send line.
*
         SUBQ.W   #1,D7
         BGT.S    CREATIVE_LOOP
*
         MOVEQ    #IO.CLOSE,D0               ; Close Destination.
         TRAP     #2
         MOVE.L   SOURCE(A6),A0
         MOVEQ    #IO.CLOSE,D0               ; Close Source.
         TRAP     #2
*
FILE_END MOVE.L   CON(A6),A0                 ; Get console ID.
         BSR      UPDATE                     ; Rewrite windows
         LEA.L    MESSAGE5,A1                ; Point to message,
         WRITE                               ; and write it!
         LEA.L    BEEP2,A3                   ; Sound !
         BSR      SET_BEEP
*
         BRA      GET_FILE                   ; Go back to start.
*
EXIT_QUE BSR      UPDATE                     ; Rewrite windows
         LEA.L    REPLY,A2                   ; String to edit
         LEA.L    TERM_PROMPT,A3             ; Prompt
         MOVEQ    #1,D7                      ; Buffer size
         BSR      EDLINE
         LEA.L    REPLY,A3
         TST.W    (A3)+
         BEQ.S    ASK_2
         CMPI.B   #'Y',(A3)
         BEQ.S    PR_EXIT
         CMPI.B   #'y',(A3)
         BEQ.S    PR_EXIT
         CMPI.B   #'N',(A3)
         BEQ      GET_FILE
         CMPI.B   #'n',(A3)
         BEQ      GET_FILE
ASK_2    MOVEQ    #SD.PROW,D0                ; Go back one row
         MOVEQ    #-1,D3                     ; Infinite timeout
         TRAP     #3
         MOVEQ    #SD.CLRLN,D0               ; Clear line
         TRAP     #3
         BRA.S    EXIT_QUE                   ; If no reply, ask again
*
PR_EXIT  MOVEQ    #RED,D1
         BSR.S    SET_INK
         LEA.L    MESSAGE6,A1
         MOVE.W   UT.MTEXT,A2
         JSR      (A2)
         MOVEQ    #IO.CLOSE,D0               ; Close console device ...
         TRAP     #2
         BRA.S    END_JOB
*
ERR_EXIT MOVE.W   UT.ERR0,A2                 ; Send error message to channel 0 ...
         JSR      (A2)
*
END_JOB  MOVEQ    #MT.FRJOB,D0               ; Then kill
         MOVEQ    #ME,D1                     ; this job.
         MOVEQ    #0,D3                      ; Send no error code.
         TRAP     #1
         BRA.S    END_JOB

*
SET_INK  MOVEQ    #-1,D3                     ; Infinite timeout
         MOVEQ    #SD.SETIN,D0               ; Set ink according to D1.B
         TRAP     #3
         RTS
*
BUFFER_SIZE
         MOVEQ    #60,D7                     ; Buffer size for MODE 4
         MOVEQ    #MT.INF,D0
         TRAP     #1
         BTST     #3,SV.MCSTA(A0)            ; Check resolution
         BEQ.S    MODE4
         MOVEQ    #22,D7                     ; Buffer size for MODE 8
MODE4    MOVE.L   CON(A6),A0                 ; Reset CHAN_ID
         RTS
*
PAN_DIST MOVEQ    #MT.INF,D0
         TRAP     #1
         MOVEQ    #6,D1                      ; Distance in MODE 4
         BTST     #3,SV.MCSTA(A0)
         BEQ.S    HIGH_RES
         MOVEQ    #12,D1                     ; Distance in MODE 8
HIGH_RES MOVE.L   CON(A6),A0                 ; Reset CHAN_ID
         MOVEQ    #-1,D3                     ; Infinite timeout
         RTS
*
WRITE_ERR
         MOVE.L   D0,D7                      ; Save error code.
         MOVEQ    #RED,D1                    ; Set ink to red.
         BSR.S    SET_INK
         MOVE.L   D7,D0                      ; Retrieve error code.
         MOVE.W   UT.ERR,A2                  ; Print requisite error message,
         JSR      (A2)
         LEA.L    BEEP3,A3                   ; Sound !
*
SET_BEEP MOVEQ    #MT.IPCOM,D0
         TRAP     #1
         RTS
*                                            ; SUBROUTINE TO EDIT STRING
EDLINE   MOVEA.L  $2804C,A1
         MOVE.L   $C(A1),$8(A1)              ; Clear keyboard queue
         MOVEQ    #SD.CHENQ,D0               ; Get cursor position
         LEA.L    CHAN_ENQ,A1
         TRAP     #3
         LEA.L    PARAMS,A5
         MOVE.L   A2,EDIT(A5)
         MOVE.L   A3,PROMPT(A5)
         MOVE.W   (A2),D2
         MOVE.W   D2,POSX(A5)                ; POS = STRING LENGTH
         LEA.L    CHAN_ENQ,A1
         MOVE.W   6(A1),POSY(A5)
         MOVE.W   D7,MAXLEN(A5)              ; Set MAXLEN
         MOVEQ    #GREEN,D1
         BSR      SET_INK
         MOVEA.L  PROMPT(A5),A1              ; Write prompt
         WRITE
         MOVEQ    #WHITE,D1
         BSR      SET_INK
         MOVEA.L  EDIT(A5),A1                ; Write string to edit
         WRITE
         BSR      POSITION                   ; Position cursor
         CURSON                              ; Enable cursor
*
ED_LOOP  BSR      POSITION
         MOVEQ    #IO.FBYTE,D0
         MOVEQ    #-1,D3                     ; Infinite timeout
         MOVEQ    #0,D1                      ; So that 0=no byte read
         TRAP     #3                         ; Read a byte
*
         TST.W    SEE_FLAG(A5)               ; Window visible
         BNE.S    KEYCHCK
         CURSOFF
         BSR      CURSWAP
         BSR      SWAP_R                     ; Make window visible
         CURSON                              ; Enable cursor
         MOVE.W   #1,SEE_FLAG(A5)            ; Set flag
         BRA.S    ED_LOOP
*
KEYCHCK  CMP.W    #KEY_ENT,D1                ; <ENTER> pressed ?
         BEQ      ENTER
         CMP.W    #KEY_F4,D1                 ; F4 pressed ?
         BEQ      REDRAW
         CMP.W    #KEY_F1,D1                 ; F1 pressed ?
         BEQ      HIDE
         CMP.W    #KEY_ESC,D1                ; <ESC> Pressed ?
         BEQ      LIN_CAN
         CMP.W    #KEY_HOME,D1               ; ALT +  pressed ?
         BEQ      MOVE_HOME
         CMP.W    #KEY_END,D1                ; ALT +  pressed ?
         BEQ      MOVE_END
         CMP.W    #KEY_DL,D1                 ; CTRL +  pressed ?
         BEQ      DEL_LEFT
         CMP.W    #KEY_DR,D1                 ; CTRL +  pressed ?
         BEQ      DEL_RIGHT
         CMP.W    #KEY_ML,D1                 ;  pressed ?
         BEQ      MOVE_LEFT
         CMP.W    #KEY_MR,D1                 ;  pressed ?
         BEQ      MOVE_RIGHT
         CMP.W    #KEY_D_LN,D1               ; CTRL + ALT +  pressed ?
         BEQ      DEL_LINE
         CMP.W    #KEY_D_RG,D1               ; CRTL + ALT +  pressed ?
         BEQ      DEL_LRG
         CMP.W    #192,D1                    ; Non printable ?
         BPL.S    NON_PRT
         CMP.W    #32,D1                     ; Non printable ?
         BMI.S    NON_PRT
         MOVEA.L  EDIT(A5),A2
         MOVE.W   (A2),D4                    ; D4.W = Length
         CMP.W    MAXLEN(A5),D4              ; Already maxlength ?
         BEQ.S    BUFFER_FULL
         CMP.W    POSX(A5),D4                ; Any chars right of cursor
         BEQ.S    NO_SCROLL
         MOVE.B   D1,-(A7)                   ; Save D1.B
         BSR      PAN_DIST
         MOVEQ    #SD.PANRT,D0
         TRAP     #3
         MOVE.B   (A7)+,D1                   ; Restore D1.B
SC_LOOP  MOVE.B   2(A2,D4.W),3(A2,D4.W)
         SUBQ.W   #1,D4
         CMP.W    POSX(A5),D4                ; Curs pos reached ?
         BPL.S    SC_LOOP
NO_SCROLL
         ADDI.W   #1,(A2)                    ; Increment length
         MOVE.W   POSX(A5),D2
         MOVE.B   D1,2(A2,D2.W)              ; Save Byte In string
         ADDI.W   #1,POSX(A5)                ; Increment position
         MOVEQ    #IO.SBYTE,D0               ; Display byte on screen
         MOVEQ    #-1,D3
         TRAP     #3
         BRA      ED_LOOP
*
BUFFER_FULL
         LEA.L    BEEP4,A3
         BSR      SET_BEEP
         BRA      ED_LOOP
*
NON_PRT  LEA.L    BEEP5,A3
         BSR      SET_BEEP
         BRA      ED_LOOP
*
HIDE     TST.W    SEE_FLAG(A5)               ; Window visible ?
         BEQ      ED_LOOP                    ; No, job already done.
         CURSOFF                             ; Suppress cursor
         BSR      SWAP_R
         CLR.W    SEE_FLAG(A5)               ; Window not visible.
         BSR      CURSWAP                    ; Swap cursor
         CURSON                              ; Activate cursor
         BRA      ED_LOOP
*
REDRAW
         CURSOFF                             ; Suppress cursor
         BSR      UPDATE                     ; Rewrite windows
         MOVEQ    #GREEN,D1
         BSR      SET_INK
         MOVEA.L  PROMPT(A5),A1              ; Message to write
         WRITE
         MOVEQ    #WHITE,D1
         BSR      SET_INK
         MOVEA.L  EDIT(A5),A1                ; Message to write
         WRITE
         CLR.W    POSY(A5)                   ; First line
         CURSON                              ; Re-enable cursor
         BRA      ED_LOOP
*
LIN_CAN  MOVEA.L  EDIT(A5),A2                ; Cancel current line
         CLR.W    (A2)                       ; Clear length
         CLR.W    POSX(A5)                   ; Reset position
         BSR      POSITION                   ; At start of line
         MOVEQ    #SD.CLRRT,D0               ; Clear end of line
         MOVEQ    #-1,D3                     ; Infinite timeout
         TRAP     #3
ENTER
         CURSOFF                             ; Supress cursor
         MOVEQ    #IO.SBYTE,D0               ; Force new line
         MOVEQ    #10,D1
         TRAP     #3
         RTS                                 ; Return to caller
MOVE_LEFT
         TST.W    POSX(A5)
         BEQ      ED_LOOP                    ; Already at start
         SUBI.W   #1,POSX(A5)                ; Move left
         BRA      ED_LOOP
*
MOVE_RIGHT
         MOVEA.L  EDIT(A5),A2
         MOVE.W   (A2),D1
         CMP.W    POSX(A5),D1
         BEQ      ED_LOOP                    ; Already at end
         ADDI.W   #1,POSX(A5)                ; Move right
         BRA      ED_LOOP
*
DEL_LEFT
         TST.W    POSX(A5)
         BEQ      ED_LOOP                    ; Already at start
         SUBI.W   #1,POSX(A5)                ; Move left
         BSR      POSITION
*
DEL_RIGHT
         MOVEA.L  EDIT(A5),A2
         MOVE.W   (A2),D1
         MOVE.W   POSX(A5),D2
         SUB.W    D2,D1                      ; D1.W No of chrs to move
         MOVE.W   D1,D3                      ; Save D1.W
         BEQ      ED_LOOP                    ; Already at end
DL_LOOP  MOVE.B   3(A2,D2.W),2(A2,D2.W)
         ADDQ.W   #1,D2
         SUBQ.W   #1,D1
         BGT.S    DL_LOOP
         SUBI.W   #1,(A2)                    ; Decrement length
         BSR      PAN_DIST
         MOVE.W   #SD.PANRT,D0               ; Pan righthand end of cursor line
         NEG.L    D1                         ; Backwards PAN
         TRAP     #3
         BRA      ED_LOOP
*
DEL_LINE CLR.W    POSX(A5)
         MOVEA.L  EDIT(A5),A2
         CLR.W    (A2)
         BSR      POSITION                   ; Move to start of line
         MOVEQ    #SD.CLRRT,D0               ; Clear line
         MOVEQ    #-1,D3
         TRAP     #3
         BRA      ED_LOOP
*
DEL_LRG  MOVEA.L  EDIT(A5),A2
         MOVE.W   POSX(A5),(A2)
         MOVEQ    #SD.CLRRT,D0               ; Clear right end of cursorline
         MOVEQ    #-1,D3
         TRAP     #3
         BRA      ED_LOOP
MOVE_HOME
         CLR.W    POSX(A5)                   ; Start of string
         BRA      ED_LOOP
*
MOVE_END MOVEA.L  EDIT(A5),A2
         MOVE.W   (A2),POSX(A5)
         BRA      ED_LOOP
*                                            ; SUBROUTINE TO POSITION CURSOR
POSITION MOVEQ    #SD.POS,D0                 ; Position cursor
         MOVE.W   POSX(A5),D1                ; Xpos
         MOVEA.L  PROMPT(A5),A2              ; + Prompt length
         ADD.W    (A2),D1
         MOVE.W   POSY(A5),D2                ; Ypos
         TRAP     #3
         RTS
*
WRITE_LOGO
         MOVE.L   LOGO(A6),A0                ; Use logo chan
         MOVEQ    #SD.CLEAR,D0               ; Clear channel
         TRAP     #3
         MOVE.L   A2,A1                      ; Message to A1
         WRITE
         RTS
*
UPDATE   LEA.L    LOGO_MES,A2
         BSR      WRITE_LOGO
         MOVE.L   CON(A6),A0                 ; Use console
         MOVEQ    #SD.BORDR,D0
         MOVEQ    #WHITE,D1                  ; White border
         MOVEQ    #1,D2                      ; One pixel wide
         MOVEQ    #-1,D3                     ; Infinite timeout
         TRAP     #3
         MOVEQ    #SD.CLEAR,D0
         TRAP     #3
         RTS
*
CURSWAP  MOVEQ    #SD.PXENQ,D0               ; Get cursor position
         LEA.L    CURSBLOCK,A1               ; At cursblock
         TRAP     #3
         OVER     -1
         MOVEQ    #SD.FILL,D0
         MOVEQ    #RED,D1                    ; Swap cursor
         LEA.L    CURSBLOCK,A1
         MOVE.W   #6,(A1)                    ; Cursor width
         MOVE.W   #10,2(A1)                  ; Cursor height
         TRAP     #3
         RTS
*
SWAP_R   TRAP     #0                         ; Supervisor mode.
         MOVE.L   #$20000+80*128,A1          ; Scrpos
         MOVE.L   MEM(A6),A2
         MOVE.L   #42*32,D1                  ; Number of longwords.
ELEM     MOVE.L   (A1),D0                    ; Get scr
         MOVE.L   (A2),(A1)+                 ; Get scr
         MOVE.L   D0,(A2)+                   ; Save old scr
         SUBQ.W   #1,D1
         BGT.S    ELEM
         ANDI.W   #$DFFF,SR                  ; Exit supervisor mode.
         RTS

*      Console device specifications

PBLOCK   DC.B     WHITE,1                    ; White border, width 1
         DC.B     BLACK,GREEN                ; Black paper, green ink
         DC.W     502,32                     ; Width, Height
         DC.W     5,90                      ; X - , Y - Coord
*
SBLOCK   DC.W     0                          ; No border
         DC.B     WHITE,BLACK                ; White paper, Black ink
         DC.W     502,10                     ; Width, Height
         DC.W     5,80                       ; X - , Y - Coord
*
CURSBLOCK
         DC.W     6,10                       ; Cursor size
         DC.W     0,0                        ; Cursor position
*
MESSAGE1 DC.W     26
         DC.B     'Enter name of source file:'
MESSAGE2 DC.W     19
         DC.B     'Name of print file:',0
MESSAGE3 DC.W     18
         DC.B     'Building file ... '
MESSAGE5 DC.W     20
         DC.B     'Print file created.',10
MESSAGE6 DC.W     19
         DC.B     'Program terminated.',0
MESSAGE7 DC.W     24
         DC.B     'OK to overwrite ? [Y/N]:'
YN_ANS   DC.W     1,'N '                     ; Line to edit
DEF1     DC.W     15
         DC.B     'flp1_WORDS_LIST'
         DS.B     62-15                      ; Remaining input buffer
RES1     DC.W     15
         DC.B     'flp1_WORDS_LIST',0
DEF2     DC.W     13
         DC.B     'ram2_TEST_TXT'
         DS.B     62-13                      ; Remaining input buffer
RES2     DC.W     13                         ; Default string
         DC.B     'ram2_TEST_TXT',0
LOGO_MES DC.W     64
         DC.B     ' Glosprint program v 1.1    F1 Hide    F4 Redraw    ESC Cansel  '
LOG2_MES DC.W     24
         DC.B     ' Glosprint program v 1.1'
TERM_PROMPT
         DC.W     26
         DC.B     'Terminate program ? [Y/N]:'
REPLY    DC.W     0,0                        ; Buffer for reply
HEAD_REQ DC.W     15
         DC.B     'Enter headline:',0
HEADLINE DC.W     15
         DC.B     'Useful wordlist'
         DS.B     62-15                      ; Remaining buffer
*
STRG1    DC.W     18
         DC.B     '          VXUD'
STRG2    DC.W     11
         DC.B     'vxud',10,10,10,0
STRG3    DC.W     35
         DC.B     '          Number of words in list: ',0
HOME_ST  DS.B     42
FORE_ST  DS.B     42
*
VARIABLES
         DS.L     7                          ; Channel ID's
*
PARAMS   DS.W     8
*
CHAN_ENQ DS.W     2                          ; WIDTH,HEIGHT
         DS.W     2                          ; XPOS,YPOS
*
         GET      'RAM2_PRINTJOB_BEEPS'
         END
